/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// AccountReport
    /// </summary>
    [DataContract]
    public partial class AccountReport :  IEquatable<AccountReport>, IValidatableObject
    {
        /// <summary>
        /// Status of the report
        /// </summary>
        /// <value>Status of the report</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum StatusEnum
        {
            
            /// <summary>
            /// Enum Missing for value: missing
            /// </summary>
            [EnumMember(Value = "missing")]
            Missing = 1,
            
            /// <summary>
            /// Enum Pending for value: pending
            /// </summary>
            [EnumMember(Value = "pending")]
            Pending = 2,
            
            /// <summary>
            /// Enum Done for value: done
            /// </summary>
            [EnumMember(Value = "done")]
            Done = 3
        }

        /// <summary>
        /// Status of the report
        /// </summary>
        /// <value>Status of the report</value>
        [DataMember(Name="status", EmitDefaultValue=false)]
        public StatusEnum Status { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="AccountReport" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected AccountReport() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="AccountReport" /> class.
        /// </summary>
        /// <param name="id">A unique ID for the AccountRecord (required).</param>
        /// <param name="accountId">The ID of the account which generated this report. (required).</param>
        /// <param name="createdDate">Date when the AccountReport was requested (required).</param>
        /// <param name="status">Status of the report (required).</param>
        /// <param name="downloadUrl">The download link for the generated XLSX (required).</param>
        /// <param name="groupId">The group ID that was used to filter the report, if any. (required).</param>
        public AccountReport(long? id = default(long?), long? accountId = default(long?), string createdDate = default(string), StatusEnum status = default(StatusEnum), string downloadUrl = default(string), long? groupId = default(long?))
        {
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new InvalidDataException("id is a required property for AccountReport and cannot be null");
            }
            else
            {
                this.Id = id;
            }
            // to ensure "accountId" is required (not null)
            if (accountId == null)
            {
                throw new InvalidDataException("accountId is a required property for AccountReport and cannot be null");
            }
            else
            {
                this.AccountId = accountId;
            }
            // to ensure "createdDate" is required (not null)
            if (createdDate == null)
            {
                throw new InvalidDataException("createdDate is a required property for AccountReport and cannot be null");
            }
            else
            {
                this.CreatedDate = createdDate;
            }
            // to ensure "status" is required (not null)
            if (status == null)
            {
                throw new InvalidDataException("status is a required property for AccountReport and cannot be null");
            }
            else
            {
                this.Status = status;
            }
            // to ensure "downloadUrl" is required (not null)
            if (downloadUrl == null)
            {
                throw new InvalidDataException("downloadUrl is a required property for AccountReport and cannot be null");
            }
            else
            {
                this.DownloadUrl = downloadUrl;
            }
            // to ensure "groupId" is required (not null)
            if (groupId == null)
            {
                throw new InvalidDataException("groupId is a required property for AccountReport and cannot be null");
            }
            else
            {
                this.GroupId = groupId;
            }
        }
        
        /// <summary>
        /// A unique ID for the AccountRecord
        /// </summary>
        /// <value>A unique ID for the AccountRecord</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public long? Id { get; set; }

        /// <summary>
        /// The ID of the account which generated this report.
        /// </summary>
        /// <value>The ID of the account which generated this report.</value>
        [DataMember(Name="account_id", EmitDefaultValue=false)]
        public long? AccountId { get; set; }

        /// <summary>
        /// Date when the AccountReport was requested
        /// </summary>
        /// <value>Date when the AccountReport was requested</value>
        [DataMember(Name="created_date", EmitDefaultValue=false)]
        public string CreatedDate { get; set; }


        /// <summary>
        /// The download link for the generated XLSX
        /// </summary>
        /// <value>The download link for the generated XLSX</value>
        [DataMember(Name="download_url", EmitDefaultValue=false)]
        public string DownloadUrl { get; set; }

        /// <summary>
        /// The group ID that was used to filter the report, if any.
        /// </summary>
        /// <value>The group ID that was used to filter the report, if any.</value>
        [DataMember(Name="group_id", EmitDefaultValue=false)]
        public long? GroupId { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class AccountReport {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  AccountId: ").Append(AccountId).Append("\n");
            sb.Append("  CreatedDate: ").Append(CreatedDate).Append("\n");
            sb.Append("  Status: ").Append(Status).Append("\n");
            sb.Append("  DownloadUrl: ").Append(DownloadUrl).Append("\n");
            sb.Append("  GroupId: ").Append(GroupId).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as AccountReport);
        }

        /// <summary>
        /// Returns true if AccountReport instances are equal
        /// </summary>
        /// <param name="input">Instance of AccountReport to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(AccountReport input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.AccountId == input.AccountId ||
                    (this.AccountId != null &&
                    this.AccountId.Equals(input.AccountId))
                ) && 
                (
                    this.CreatedDate == input.CreatedDate ||
                    (this.CreatedDate != null &&
                    this.CreatedDate.Equals(input.CreatedDate))
                ) && 
                (
                    this.Status == input.Status ||
                    (this.Status != null &&
                    this.Status.Equals(input.Status))
                ) && 
                (
                    this.DownloadUrl == input.DownloadUrl ||
                    (this.DownloadUrl != null &&
                    this.DownloadUrl.Equals(input.DownloadUrl))
                ) && 
                (
                    this.GroupId == input.GroupId ||
                    (this.GroupId != null &&
                    this.GroupId.Equals(input.GroupId))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.AccountId != null)
                    hashCode = hashCode * 59 + this.AccountId.GetHashCode();
                if (this.CreatedDate != null)
                    hashCode = hashCode * 59 + this.CreatedDate.GetHashCode();
                if (this.Status != null)
                    hashCode = hashCode * 59 + this.Status.GetHashCode();
                if (this.DownloadUrl != null)
                    hashCode = hashCode * 59 + this.DownloadUrl.GetHashCode();
                if (this.GroupId != null)
                    hashCode = hashCode * 59 + this.GroupId.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
