/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Author
    /// </summary>
    [DataContract]
    public partial class Author :  IEquatable<Author>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="Author" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected Author() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="Author" /> class.
        /// </summary>
        /// <param name="id">Author id (required).</param>
        /// <param name="fullName">Author full name (required).</param>
        /// <param name="isActive">True if author has published items (required).</param>
        /// <param name="urlName">Author url name (required).</param>
        /// <param name="orcidId">Author Orcid (required).</param>
        public Author(long? id = default(long?), string fullName = default(string), bool? isActive = default(bool?), string urlName = default(string), string orcidId = default(string))
        {
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new InvalidDataException("id is a required property for Author and cannot be null");
            }
            else
            {
                this.Id = id;
            }
            // to ensure "fullName" is required (not null)
            if (fullName == null)
            {
                throw new InvalidDataException("fullName is a required property for Author and cannot be null");
            }
            else
            {
                this.FullName = fullName;
            }
            // to ensure "isActive" is required (not null)
            if (isActive == null)
            {
                throw new InvalidDataException("isActive is a required property for Author and cannot be null");
            }
            else
            {
                this.IsActive = isActive;
            }
            // to ensure "urlName" is required (not null)
            if (urlName == null)
            {
                throw new InvalidDataException("urlName is a required property for Author and cannot be null");
            }
            else
            {
                this.UrlName = urlName;
            }
            // to ensure "orcidId" is required (not null)
            if (orcidId == null)
            {
                throw new InvalidDataException("orcidId is a required property for Author and cannot be null");
            }
            else
            {
                this.OrcidId = orcidId;
            }
        }
        
        /// <summary>
        /// Author id
        /// </summary>
        /// <value>Author id</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public long? Id { get; set; }

        /// <summary>
        /// Author full name
        /// </summary>
        /// <value>Author full name</value>
        [DataMember(Name="full_name", EmitDefaultValue=false)]
        public string FullName { get; set; }

        /// <summary>
        /// True if author has published items
        /// </summary>
        /// <value>True if author has published items</value>
        [DataMember(Name="is_active", EmitDefaultValue=false)]
        public bool? IsActive { get; set; }

        /// <summary>
        /// Author url name
        /// </summary>
        /// <value>Author url name</value>
        [DataMember(Name="url_name", EmitDefaultValue=false)]
        public string UrlName { get; set; }

        /// <summary>
        /// Author Orcid
        /// </summary>
        /// <value>Author Orcid</value>
        [DataMember(Name="orcid_id", EmitDefaultValue=false)]
        public string OrcidId { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Author {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  FullName: ").Append(FullName).Append("\n");
            sb.Append("  IsActive: ").Append(IsActive).Append("\n");
            sb.Append("  UrlName: ").Append(UrlName).Append("\n");
            sb.Append("  OrcidId: ").Append(OrcidId).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as Author);
        }

        /// <summary>
        /// Returns true if Author instances are equal
        /// </summary>
        /// <param name="input">Instance of Author to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Author input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.FullName == input.FullName ||
                    (this.FullName != null &&
                    this.FullName.Equals(input.FullName))
                ) && 
                (
                    this.IsActive == input.IsActive ||
                    (this.IsActive != null &&
                    this.IsActive.Equals(input.IsActive))
                ) && 
                (
                    this.UrlName == input.UrlName ||
                    (this.UrlName != null &&
                    this.UrlName.Equals(input.UrlName))
                ) && 
                (
                    this.OrcidId == input.OrcidId ||
                    (this.OrcidId != null &&
                    this.OrcidId.Equals(input.OrcidId))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.FullName != null)
                    hashCode = hashCode * 59 + this.FullName.GetHashCode();
                if (this.IsActive != null)
                    hashCode = hashCode * 59 + this.IsActive.GetHashCode();
                if (this.UrlName != null)
                    hashCode = hashCode * 59 + this.UrlName.GetHashCode();
                if (this.OrcidId != null)
                    hashCode = hashCode * 59 + this.OrcidId.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
