/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// AuthorComplete
    /// </summary>
    [DataContract]
    public partial class AuthorComplete : Author,  IEquatable<AuthorComplete>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="AuthorComplete" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected AuthorComplete() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="AuthorComplete" /> class.
        /// </summary>
        /// <param name="id">Author id (required).</param>
        /// <param name="fullName">Author full name (required).</param>
        /// <param name="isActive">True if author has published items (required).</param>
        /// <param name="urlName">Author url name (required).</param>
        /// <param name="orcidId">Author Orcid (required).</param>
        /// <param name="institutionId">Institution id (required).</param>
        /// <param name="groupId">Group id (required).</param>
        /// <param name="firstName">First Name (required).</param>
        /// <param name="lastName">Last Name (required).</param>
        /// <param name="isPublic">if 1 then the author has published items (required).</param>
        /// <param name="jobTitle">Job title (required).</param>
        public AuthorComplete(long? id = default(long?), string fullName = default(string), bool? isActive = default(bool?), string urlName = default(string), string orcidId = default(string), long? institutionId = default(long?), long? groupId = default(long?), string firstName = default(string), string lastName = default(string), long? isPublic = default(long?), string jobTitle = default(string)) : base()
        {
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new InvalidDataException("id is a required property for AuthorComplete and cannot be null");
            }
            else
            {
                this.Id = id;
            }
            // to ensure "fullName" is required (not null)
            if (fullName == null)
            {
                throw new InvalidDataException("fullName is a required property for AuthorComplete and cannot be null");
            }
            else
            {
                this.FullName = fullName;
            }
            // to ensure "isActive" is required (not null)
            if (isActive == null)
            {
                throw new InvalidDataException("isActive is a required property for AuthorComplete and cannot be null");
            }
            else
            {
                this.IsActive = isActive;
            }
            // to ensure "urlName" is required (not null)
            if (urlName == null)
            {
                throw new InvalidDataException("urlName is a required property for AuthorComplete and cannot be null");
            }
            else
            {
                this.UrlName = urlName;
            }
            // to ensure "orcidId" is required (not null)
            if (orcidId == null)
            {
                throw new InvalidDataException("orcidId is a required property for AuthorComplete and cannot be null");
            }
            else
            {
                this.OrcidId = orcidId;
            }
            // to ensure "institutionId" is required (not null)
            if (institutionId == null)
            {
                throw new InvalidDataException("institutionId is a required property for AuthorComplete and cannot be null");
            }
            else
            {
                this.InstitutionId = institutionId;
            }
            // to ensure "groupId" is required (not null)
            if (groupId == null)
            {
                throw new InvalidDataException("groupId is a required property for AuthorComplete and cannot be null");
            }
            else
            {
                this.GroupId = groupId;
            }
            // to ensure "firstName" is required (not null)
            if (firstName == null)
            {
                throw new InvalidDataException("firstName is a required property for AuthorComplete and cannot be null");
            }
            else
            {
                this.FirstName = firstName;
            }
            // to ensure "lastName" is required (not null)
            if (lastName == null)
            {
                throw new InvalidDataException("lastName is a required property for AuthorComplete and cannot be null");
            }
            else
            {
                this.LastName = lastName;
            }
            // to ensure "isPublic" is required (not null)
            if (isPublic == null)
            {
                throw new InvalidDataException("isPublic is a required property for AuthorComplete and cannot be null");
            }
            else
            {
                this.IsPublic = isPublic;
            }
            // to ensure "jobTitle" is required (not null)
            if (jobTitle == null)
            {
                throw new InvalidDataException("jobTitle is a required property for AuthorComplete and cannot be null");
            }
            else
            {
                this.JobTitle = jobTitle;
            }
        }
        
        /// <summary>
        /// Author id
        /// </summary>
        /// <value>Author id</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public long? Id { get; set; }

        /// <summary>
        /// Author full name
        /// </summary>
        /// <value>Author full name</value>
        [DataMember(Name="full_name", EmitDefaultValue=false)]
        public string FullName { get; set; }

        /// <summary>
        /// True if author has published items
        /// </summary>
        /// <value>True if author has published items</value>
        [DataMember(Name="is_active", EmitDefaultValue=false)]
        public bool? IsActive { get; set; }

        /// <summary>
        /// Author url name
        /// </summary>
        /// <value>Author url name</value>
        [DataMember(Name="url_name", EmitDefaultValue=false)]
        public string UrlName { get; set; }

        /// <summary>
        /// Author Orcid
        /// </summary>
        /// <value>Author Orcid</value>
        [DataMember(Name="orcid_id", EmitDefaultValue=false)]
        public string OrcidId { get; set; }

        /// <summary>
        /// Institution id
        /// </summary>
        /// <value>Institution id</value>
        [DataMember(Name="institution_id", EmitDefaultValue=false)]
        public long? InstitutionId { get; set; }

        /// <summary>
        /// Group id
        /// </summary>
        /// <value>Group id</value>
        [DataMember(Name="group_id", EmitDefaultValue=false)]
        public long? GroupId { get; set; }

        /// <summary>
        /// First Name
        /// </summary>
        /// <value>First Name</value>
        [DataMember(Name="first_name", EmitDefaultValue=false)]
        public string FirstName { get; set; }

        /// <summary>
        /// Last Name
        /// </summary>
        /// <value>Last Name</value>
        [DataMember(Name="last_name", EmitDefaultValue=false)]
        public string LastName { get; set; }

        /// <summary>
        /// if 1 then the author has published items
        /// </summary>
        /// <value>if 1 then the author has published items</value>
        [DataMember(Name="is_public", EmitDefaultValue=false)]
        public long? IsPublic { get; set; }

        /// <summary>
        /// Job title
        /// </summary>
        /// <value>Job title</value>
        [DataMember(Name="job_title", EmitDefaultValue=false)]
        public string JobTitle { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class AuthorComplete {\n");
            sb.Append("  ").Append(base.ToString().Replace("\n", "\n  ")).Append("\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  FullName: ").Append(FullName).Append("\n");
            sb.Append("  IsActive: ").Append(IsActive).Append("\n");
            sb.Append("  UrlName: ").Append(UrlName).Append("\n");
            sb.Append("  OrcidId: ").Append(OrcidId).Append("\n");
            sb.Append("  InstitutionId: ").Append(InstitutionId).Append("\n");
            sb.Append("  GroupId: ").Append(GroupId).Append("\n");
            sb.Append("  FirstName: ").Append(FirstName).Append("\n");
            sb.Append("  LastName: ").Append(LastName).Append("\n");
            sb.Append("  IsPublic: ").Append(IsPublic).Append("\n");
            sb.Append("  JobTitle: ").Append(JobTitle).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public override string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as AuthorComplete);
        }

        /// <summary>
        /// Returns true if AuthorComplete instances are equal
        /// </summary>
        /// <param name="input">Instance of AuthorComplete to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(AuthorComplete input)
        {
            if (input == null)
                return false;

            return base.Equals(input) && 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && base.Equals(input) && 
                (
                    this.FullName == input.FullName ||
                    (this.FullName != null &&
                    this.FullName.Equals(input.FullName))
                ) && base.Equals(input) && 
                (
                    this.IsActive == input.IsActive ||
                    (this.IsActive != null &&
                    this.IsActive.Equals(input.IsActive))
                ) && base.Equals(input) && 
                (
                    this.UrlName == input.UrlName ||
                    (this.UrlName != null &&
                    this.UrlName.Equals(input.UrlName))
                ) && base.Equals(input) && 
                (
                    this.OrcidId == input.OrcidId ||
                    (this.OrcidId != null &&
                    this.OrcidId.Equals(input.OrcidId))
                ) && base.Equals(input) && 
                (
                    this.InstitutionId == input.InstitutionId ||
                    (this.InstitutionId != null &&
                    this.InstitutionId.Equals(input.InstitutionId))
                ) && base.Equals(input) && 
                (
                    this.GroupId == input.GroupId ||
                    (this.GroupId != null &&
                    this.GroupId.Equals(input.GroupId))
                ) && base.Equals(input) && 
                (
                    this.FirstName == input.FirstName ||
                    (this.FirstName != null &&
                    this.FirstName.Equals(input.FirstName))
                ) && base.Equals(input) && 
                (
                    this.LastName == input.LastName ||
                    (this.LastName != null &&
                    this.LastName.Equals(input.LastName))
                ) && base.Equals(input) && 
                (
                    this.IsPublic == input.IsPublic ||
                    (this.IsPublic != null &&
                    this.IsPublic.Equals(input.IsPublic))
                ) && base.Equals(input) && 
                (
                    this.JobTitle == input.JobTitle ||
                    (this.JobTitle != null &&
                    this.JobTitle.Equals(input.JobTitle))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = base.GetHashCode();
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.FullName != null)
                    hashCode = hashCode * 59 + this.FullName.GetHashCode();
                if (this.IsActive != null)
                    hashCode = hashCode * 59 + this.IsActive.GetHashCode();
                if (this.UrlName != null)
                    hashCode = hashCode * 59 + this.UrlName.GetHashCode();
                if (this.OrcidId != null)
                    hashCode = hashCode * 59 + this.OrcidId.GetHashCode();
                if (this.InstitutionId != null)
                    hashCode = hashCode * 59 + this.InstitutionId.GetHashCode();
                if (this.GroupId != null)
                    hashCode = hashCode * 59 + this.GroupId.GetHashCode();
                if (this.FirstName != null)
                    hashCode = hashCode * 59 + this.FirstName.GetHashCode();
                if (this.LastName != null)
                    hashCode = hashCode * 59 + this.LastName.GetHashCode();
                if (this.IsPublic != null)
                    hashCode = hashCode * 59 + this.IsPublic.GetHashCode();
                if (this.JobTitle != null)
                    hashCode = hashCode * 59 + this.JobTitle.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            foreach(var x in BaseValidate(validationContext)) yield return x;
            yield break;
        }
    }

}
