/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// CategoriesCreator
    /// </summary>
    [DataContract]
    public partial class CategoriesCreator :  IEquatable<CategoriesCreator>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CategoriesCreator" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected CategoriesCreator() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="CategoriesCreator" /> class.
        /// </summary>
        /// <param name="categories">List of category ids (required).</param>
        public CategoriesCreator(List<long?> categories = default(List<long?>))
        {
            // to ensure "categories" is required (not null)
            if (categories == null)
            {
                throw new InvalidDataException("categories is a required property for CategoriesCreator and cannot be null");
            }
            else
            {
                this.Categories = categories;
            }
        }
        
        /// <summary>
        /// List of category ids
        /// </summary>
        /// <value>List of category ids</value>
        [DataMember(Name="categories", EmitDefaultValue=false)]
        public List<long?> Categories { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class CategoriesCreator {\n");
            sb.Append("  Categories: ").Append(Categories).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CategoriesCreator);
        }

        /// <summary>
        /// Returns true if CategoriesCreator instances are equal
        /// </summary>
        /// <param name="input">Instance of CategoriesCreator to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CategoriesCreator input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Categories == input.Categories ||
                    this.Categories != null &&
                    this.Categories.SequenceEqual(input.Categories)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Categories != null)
                    hashCode = hashCode * 59 + this.Categories.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
