/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// CollectionHandle
    /// </summary>
    [DataContract]
    public partial class CollectionHandle :  IEquatable<CollectionHandle>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CollectionHandle" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected CollectionHandle() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="CollectionHandle" /> class.
        /// </summary>
        /// <param name="handle">Reserved Handle (required).</param>
        public CollectionHandle(string handle = default(string))
        {
            // to ensure "handle" is required (not null)
            if (handle == null)
            {
                throw new InvalidDataException("handle is a required property for CollectionHandle and cannot be null");
            }
            else
            {
                this.Handle = handle;
            }
        }
        
        /// <summary>
        /// Reserved Handle
        /// </summary>
        /// <value>Reserved Handle</value>
        [DataMember(Name="handle", EmitDefaultValue=false)]
        public string Handle { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class CollectionHandle {\n");
            sb.Append("  Handle: ").Append(Handle).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CollectionHandle);
        }

        /// <summary>
        /// Returns true if CollectionHandle instances are equal
        /// </summary>
        /// <param name="input">Instance of CollectionHandle to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CollectionHandle input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Handle == input.Handle ||
                    (this.Handle != null &&
                    this.Handle.Equals(input.Handle))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Handle != null)
                    hashCode = hashCode * 59 + this.Handle.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
