/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Curation
    /// </summary>
    [DataContract]
    public partial class Curation :  IEquatable<Curation>, IValidatableObject
    {
        /// <summary>
        /// The status of the review.
        /// </summary>
        /// <value>The status of the review.</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum StatusEnum
        {
            
            /// <summary>
            /// Enum Pending for value: pending
            /// </summary>
            [EnumMember(Value = "pending")]
            Pending = 1,
            
            /// <summary>
            /// Enum Approved for value: approved
            /// </summary>
            [EnumMember(Value = "approved")]
            Approved = 2,
            
            /// <summary>
            /// Enum Rejected for value: rejected
            /// </summary>
            [EnumMember(Value = "rejected")]
            Rejected = 3,
            
            /// <summary>
            /// Enum Closed for value: closed
            /// </summary>
            [EnumMember(Value = "closed")]
            Closed = 4
        }

        /// <summary>
        /// The status of the review.
        /// </summary>
        /// <value>The status of the review.</value>
        [DataMember(Name="status", EmitDefaultValue=false)]
        public StatusEnum Status { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="Curation" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected Curation() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="Curation" /> class.
        /// </summary>
        /// <param name="id">The review id (required).</param>
        /// <param name="groupId">The group in which the article is present. (required).</param>
        /// <param name="accountId">The ID of the account of the owner of the article of this review. (required).</param>
        /// <param name="assignedTo">The ID of the account to which this review is assigned. (required).</param>
        /// <param name="articleId">The ID of the article of this review. (required).</param>
        /// <param name="version">The Version number of the article in review. (required).</param>
        /// <param name="commentsCount">The number of comments in the review. (required).</param>
        /// <param name="status">The status of the review. (required).</param>
        /// <param name="createdDate">The creation date of the review. (required).</param>
        /// <param name="modifiedDate">The date the review has been modified. (required).</param>
        public Curation(long? id = default(long?), long? groupId = default(long?), long? accountId = default(long?), long? assignedTo = default(long?), long? articleId = default(long?), long? version = default(long?), long? commentsCount = default(long?), StatusEnum status = default(StatusEnum), string createdDate = default(string), string modifiedDate = default(string))
        {
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new InvalidDataException("id is a required property for Curation and cannot be null");
            }
            else
            {
                this.Id = id;
            }
            // to ensure "groupId" is required (not null)
            if (groupId == null)
            {
                throw new InvalidDataException("groupId is a required property for Curation and cannot be null");
            }
            else
            {
                this.GroupId = groupId;
            }
            // to ensure "accountId" is required (not null)
            if (accountId == null)
            {
                throw new InvalidDataException("accountId is a required property for Curation and cannot be null");
            }
            else
            {
                this.AccountId = accountId;
            }
            // to ensure "assignedTo" is required (not null)
            if (assignedTo == null)
            {
                throw new InvalidDataException("assignedTo is a required property for Curation and cannot be null");
            }
            else
            {
                this.AssignedTo = assignedTo;
            }
            // to ensure "articleId" is required (not null)
            if (articleId == null)
            {
                throw new InvalidDataException("articleId is a required property for Curation and cannot be null");
            }
            else
            {
                this.ArticleId = articleId;
            }
            // to ensure "version" is required (not null)
            if (version == null)
            {
                throw new InvalidDataException("version is a required property for Curation and cannot be null");
            }
            else
            {
                this.Version = version;
            }
            // to ensure "commentsCount" is required (not null)
            if (commentsCount == null)
            {
                throw new InvalidDataException("commentsCount is a required property for Curation and cannot be null");
            }
            else
            {
                this.CommentsCount = commentsCount;
            }
            // to ensure "status" is required (not null)
            if (status == null)
            {
                throw new InvalidDataException("status is a required property for Curation and cannot be null");
            }
            else
            {
                this.Status = status;
            }
            // to ensure "createdDate" is required (not null)
            if (createdDate == null)
            {
                throw new InvalidDataException("createdDate is a required property for Curation and cannot be null");
            }
            else
            {
                this.CreatedDate = createdDate;
            }
            // to ensure "modifiedDate" is required (not null)
            if (modifiedDate == null)
            {
                throw new InvalidDataException("modifiedDate is a required property for Curation and cannot be null");
            }
            else
            {
                this.ModifiedDate = modifiedDate;
            }
        }
        
        /// <summary>
        /// The review id
        /// </summary>
        /// <value>The review id</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public long? Id { get; set; }

        /// <summary>
        /// The group in which the article is present.
        /// </summary>
        /// <value>The group in which the article is present.</value>
        [DataMember(Name="group_id", EmitDefaultValue=false)]
        public long? GroupId { get; set; }

        /// <summary>
        /// The ID of the account of the owner of the article of this review.
        /// </summary>
        /// <value>The ID of the account of the owner of the article of this review.</value>
        [DataMember(Name="account_id", EmitDefaultValue=false)]
        public long? AccountId { get; set; }

        /// <summary>
        /// The ID of the account to which this review is assigned.
        /// </summary>
        /// <value>The ID of the account to which this review is assigned.</value>
        [DataMember(Name="assigned_to", EmitDefaultValue=false)]
        public long? AssignedTo { get; set; }

        /// <summary>
        /// The ID of the article of this review.
        /// </summary>
        /// <value>The ID of the article of this review.</value>
        [DataMember(Name="article_id", EmitDefaultValue=false)]
        public long? ArticleId { get; set; }

        /// <summary>
        /// The Version number of the article in review.
        /// </summary>
        /// <value>The Version number of the article in review.</value>
        [DataMember(Name="version", EmitDefaultValue=false)]
        public long? Version { get; set; }

        /// <summary>
        /// The number of comments in the review.
        /// </summary>
        /// <value>The number of comments in the review.</value>
        [DataMember(Name="comments_count", EmitDefaultValue=false)]
        public long? CommentsCount { get; set; }


        /// <summary>
        /// The creation date of the review.
        /// </summary>
        /// <value>The creation date of the review.</value>
        [DataMember(Name="created_date", EmitDefaultValue=false)]
        public string CreatedDate { get; set; }

        /// <summary>
        /// The date the review has been modified.
        /// </summary>
        /// <value>The date the review has been modified.</value>
        [DataMember(Name="modified_date", EmitDefaultValue=false)]
        public string ModifiedDate { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Curation {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  GroupId: ").Append(GroupId).Append("\n");
            sb.Append("  AccountId: ").Append(AccountId).Append("\n");
            sb.Append("  AssignedTo: ").Append(AssignedTo).Append("\n");
            sb.Append("  ArticleId: ").Append(ArticleId).Append("\n");
            sb.Append("  Version: ").Append(Version).Append("\n");
            sb.Append("  CommentsCount: ").Append(CommentsCount).Append("\n");
            sb.Append("  Status: ").Append(Status).Append("\n");
            sb.Append("  CreatedDate: ").Append(CreatedDate).Append("\n");
            sb.Append("  ModifiedDate: ").Append(ModifiedDate).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as Curation);
        }

        /// <summary>
        /// Returns true if Curation instances are equal
        /// </summary>
        /// <param name="input">Instance of Curation to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Curation input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.GroupId == input.GroupId ||
                    (this.GroupId != null &&
                    this.GroupId.Equals(input.GroupId))
                ) && 
                (
                    this.AccountId == input.AccountId ||
                    (this.AccountId != null &&
                    this.AccountId.Equals(input.AccountId))
                ) && 
                (
                    this.AssignedTo == input.AssignedTo ||
                    (this.AssignedTo != null &&
                    this.AssignedTo.Equals(input.AssignedTo))
                ) && 
                (
                    this.ArticleId == input.ArticleId ||
                    (this.ArticleId != null &&
                    this.ArticleId.Equals(input.ArticleId))
                ) && 
                (
                    this.Version == input.Version ||
                    (this.Version != null &&
                    this.Version.Equals(input.Version))
                ) && 
                (
                    this.CommentsCount == input.CommentsCount ||
                    (this.CommentsCount != null &&
                    this.CommentsCount.Equals(input.CommentsCount))
                ) && 
                (
                    this.Status == input.Status ||
                    (this.Status != null &&
                    this.Status.Equals(input.Status))
                ) && 
                (
                    this.CreatedDate == input.CreatedDate ||
                    (this.CreatedDate != null &&
                    this.CreatedDate.Equals(input.CreatedDate))
                ) && 
                (
                    this.ModifiedDate == input.ModifiedDate ||
                    (this.ModifiedDate != null &&
                    this.ModifiedDate.Equals(input.ModifiedDate))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.GroupId != null)
                    hashCode = hashCode * 59 + this.GroupId.GetHashCode();
                if (this.AccountId != null)
                    hashCode = hashCode * 59 + this.AccountId.GetHashCode();
                if (this.AssignedTo != null)
                    hashCode = hashCode * 59 + this.AssignedTo.GetHashCode();
                if (this.ArticleId != null)
                    hashCode = hashCode * 59 + this.ArticleId.GetHashCode();
                if (this.Version != null)
                    hashCode = hashCode * 59 + this.Version.GetHashCode();
                if (this.CommentsCount != null)
                    hashCode = hashCode * 59 + this.CommentsCount.GetHashCode();
                if (this.Status != null)
                    hashCode = hashCode * 59 + this.Status.GetHashCode();
                if (this.CreatedDate != null)
                    hashCode = hashCode * 59 + this.CreatedDate.GetHashCode();
                if (this.ModifiedDate != null)
                    hashCode = hashCode * 59 + this.ModifiedDate.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
