/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// InstitutionAccountsSearch
    /// </summary>
    [DataContract]
    public partial class InstitutionAccountsSearch :  IEquatable<InstitutionAccountsSearch>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="InstitutionAccountsSearch" /> class.
        /// </summary>
        /// <param name="searchFor">Search term.</param>
        /// <param name="isActive">Filter by active status.</param>
        /// <param name="page">Page number. Used for pagination with page_size.</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (default to 10).</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query.</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit.</param>
        /// <param name="institutionUserId">filter by institution_user_id.</param>
        /// <param name="email">filter by email.</param>
        public InstitutionAccountsSearch(string searchFor = default(string), long? isActive = default(long?), long? page = default(long?), long? pageSize = 10, long? limit = default(long?), long? offset = default(long?), string institutionUserId = default(string), string email = default(string))
        {
            this.SearchFor = searchFor;
            this.IsActive = isActive;
            this.Page = page;
            // use default value if no "pageSize" provided
            if (pageSize == null)
            {
                this.PageSize = 10;
            }
            else
            {
                this.PageSize = pageSize;
            }
            this.Limit = limit;
            this.Offset = offset;
            this.InstitutionUserId = institutionUserId;
            this.Email = email;
        }
        
        /// <summary>
        /// Search term
        /// </summary>
        /// <value>Search term</value>
        [DataMember(Name="search_for", EmitDefaultValue=false)]
        public string SearchFor { get; set; }

        /// <summary>
        /// Filter by active status
        /// </summary>
        /// <value>Filter by active status</value>
        [DataMember(Name="is_active", EmitDefaultValue=false)]
        public long? IsActive { get; set; }

        /// <summary>
        /// Page number. Used for pagination with page_size
        /// </summary>
        /// <value>Page number. Used for pagination with page_size</value>
        [DataMember(Name="page", EmitDefaultValue=false)]
        public long? Page { get; set; }

        /// <summary>
        /// The number of results included on a page. Used for pagination with page
        /// </summary>
        /// <value>The number of results included on a page. Used for pagination with page</value>
        [DataMember(Name="page_size", EmitDefaultValue=false)]
        public long? PageSize { get; set; }

        /// <summary>
        /// Number of results included on a page. Used for pagination with query
        /// </summary>
        /// <value>Number of results included on a page. Used for pagination with query</value>
        [DataMember(Name="limit", EmitDefaultValue=false)]
        public long? Limit { get; set; }

        /// <summary>
        /// Where to start the listing(the offset of the first result). Used for pagination with limit
        /// </summary>
        /// <value>Where to start the listing(the offset of the first result). Used for pagination with limit</value>
        [DataMember(Name="offset", EmitDefaultValue=false)]
        public long? Offset { get; set; }

        /// <summary>
        /// filter by institution_user_id
        /// </summary>
        /// <value>filter by institution_user_id</value>
        [DataMember(Name="institution_user_id", EmitDefaultValue=false)]
        public string InstitutionUserId { get; set; }

        /// <summary>
        /// filter by email
        /// </summary>
        /// <value>filter by email</value>
        [DataMember(Name="email", EmitDefaultValue=false)]
        public string Email { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class InstitutionAccountsSearch {\n");
            sb.Append("  SearchFor: ").Append(SearchFor).Append("\n");
            sb.Append("  IsActive: ").Append(IsActive).Append("\n");
            sb.Append("  Page: ").Append(Page).Append("\n");
            sb.Append("  PageSize: ").Append(PageSize).Append("\n");
            sb.Append("  Limit: ").Append(Limit).Append("\n");
            sb.Append("  Offset: ").Append(Offset).Append("\n");
            sb.Append("  InstitutionUserId: ").Append(InstitutionUserId).Append("\n");
            sb.Append("  Email: ").Append(Email).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as InstitutionAccountsSearch);
        }

        /// <summary>
        /// Returns true if InstitutionAccountsSearch instances are equal
        /// </summary>
        /// <param name="input">Instance of InstitutionAccountsSearch to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(InstitutionAccountsSearch input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.SearchFor == input.SearchFor ||
                    (this.SearchFor != null &&
                    this.SearchFor.Equals(input.SearchFor))
                ) && 
                (
                    this.IsActive == input.IsActive ||
                    (this.IsActive != null &&
                    this.IsActive.Equals(input.IsActive))
                ) && 
                (
                    this.Page == input.Page ||
                    (this.Page != null &&
                    this.Page.Equals(input.Page))
                ) && 
                (
                    this.PageSize == input.PageSize ||
                    (this.PageSize != null &&
                    this.PageSize.Equals(input.PageSize))
                ) && 
                (
                    this.Limit == input.Limit ||
                    (this.Limit != null &&
                    this.Limit.Equals(input.Limit))
                ) && 
                (
                    this.Offset == input.Offset ||
                    (this.Offset != null &&
                    this.Offset.Equals(input.Offset))
                ) && 
                (
                    this.InstitutionUserId == input.InstitutionUserId ||
                    (this.InstitutionUserId != null &&
                    this.InstitutionUserId.Equals(input.InstitutionUserId))
                ) && 
                (
                    this.Email == input.Email ||
                    (this.Email != null &&
                    this.Email.Equals(input.Email))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.SearchFor != null)
                    hashCode = hashCode * 59 + this.SearchFor.GetHashCode();
                if (this.IsActive != null)
                    hashCode = hashCode * 59 + this.IsActive.GetHashCode();
                if (this.Page != null)
                    hashCode = hashCode * 59 + this.Page.GetHashCode();
                if (this.PageSize != null)
                    hashCode = hashCode * 59 + this.PageSize.GetHashCode();
                if (this.Limit != null)
                    hashCode = hashCode * 59 + this.Limit.GetHashCode();
                if (this.Offset != null)
                    hashCode = hashCode * 59 + this.Offset.GetHashCode();
                if (this.InstitutionUserId != null)
                    hashCode = hashCode * 59 + this.InstitutionUserId.GetHashCode();
                if (this.Email != null)
                    hashCode = hashCode * 59 + this.Email.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // IsActive (long?) maximum
            if(this.IsActive > (long?)1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for IsActive, must be a value less than or equal to 1.", new [] { "IsActive" });
            }

            // IsActive (long?) minimum
            if(this.IsActive < (long?)0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for IsActive, must be a value greater than or equal to 0.", new [] { "IsActive" });
            }

            // Page (long?) maximum
            if(this.Page > (long?)5000)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Page, must be a value less than or equal to 5000.", new [] { "Page" });
            }

            // Page (long?) minimum
            if(this.Page < (long?)1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Page, must be a value greater than or equal to 1.", new [] { "Page" });
            }

            // PageSize (long?) maximum
            if(this.PageSize > (long?)1000)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for PageSize, must be a value less than or equal to 1000.", new [] { "PageSize" });
            }

            // PageSize (long?) minimum
            if(this.PageSize < (long?)1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for PageSize, must be a value greater than or equal to 1.", new [] { "PageSize" });
            }

            // Limit (long?) maximum
            if(this.Limit > (long?)1000)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Limit, must be a value less than or equal to 1000.", new [] { "Limit" });
            }

            // Limit (long?) minimum
            if(this.Limit < (long?)1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Limit, must be a value greater than or equal to 1.", new [] { "Limit" });
            }

            // Offset (long?) maximum
            if(this.Offset > (long?)5000)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Offset, must be a value less than or equal to 5000.", new [] { "Offset" });
            }

            // Offset (long?) minimum
            if(this.Offset < (long?)0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Offset, must be a value greater than or equal to 0.", new [] { "Offset" });
            }

            yield break;
        }
    }

}
