/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// LocationWarningsUpdate
    /// </summary>
    [DataContract]
    public partial class LocationWarningsUpdate :  IEquatable<LocationWarningsUpdate>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="LocationWarningsUpdate" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected LocationWarningsUpdate() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="LocationWarningsUpdate" /> class.
        /// </summary>
        /// <param name="location">Url for entity (required).</param>
        /// <param name="warnings">Issues encountered during the operation (required).</param>
        public LocationWarningsUpdate(string location = default(string), List<string> warnings = default(List<string>))
        {
            // to ensure "location" is required (not null)
            if (location == null)
            {
                throw new InvalidDataException("location is a required property for LocationWarningsUpdate and cannot be null");
            }
            else
            {
                this.Location = location;
            }
            // to ensure "warnings" is required (not null)
            if (warnings == null)
            {
                throw new InvalidDataException("warnings is a required property for LocationWarningsUpdate and cannot be null");
            }
            else
            {
                this.Warnings = warnings;
            }
        }
        
        /// <summary>
        /// Url for entity
        /// </summary>
        /// <value>Url for entity</value>
        [DataMember(Name="location", EmitDefaultValue=false)]
        public string Location { get; set; }

        /// <summary>
        /// Issues encountered during the operation
        /// </summary>
        /// <value>Issues encountered during the operation</value>
        [DataMember(Name="warnings", EmitDefaultValue=false)]
        public List<string> Warnings { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class LocationWarningsUpdate {\n");
            sb.Append("  Location: ").Append(Location).Append("\n");
            sb.Append("  Warnings: ").Append(Warnings).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as LocationWarningsUpdate);
        }

        /// <summary>
        /// Returns true if LocationWarningsUpdate instances are equal
        /// </summary>
        /// <param name="input">Instance of LocationWarningsUpdate to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(LocationWarningsUpdate input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Location == input.Location ||
                    (this.Location != null &&
                    this.Location.Equals(input.Location))
                ) && 
                (
                    this.Warnings == input.Warnings ||
                    this.Warnings != null &&
                    this.Warnings.SequenceEqual(input.Warnings)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Location != null)
                    hashCode = hashCode * 59 + this.Location.GetHashCode();
                if (this.Warnings != null)
                    hashCode = hashCode * 59 + this.Warnings.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
