/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// PrivateAuthorsSearch
    /// </summary>
    [DataContract]
    public partial class PrivateAuthorsSearch :  IEquatable<PrivateAuthorsSearch>, IValidatableObject
    {
        /// <summary>
        /// The field by which to order. Default varies by endpoint/resource.
        /// </summary>
        /// <value>The field by which to order. Default varies by endpoint/resource.</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum OrderEnum
        {
            
            /// <summary>
            /// Enum Publisheddate for value: published_date
            /// </summary>
            [EnumMember(Value = "published_date")]
            Publisheddate = 1,
            
            /// <summary>
            /// Enum Modifieddate for value: modified_date
            /// </summary>
            [EnumMember(Value = "modified_date")]
            Modifieddate = 2,
            
            /// <summary>
            /// Enum Views for value: views
            /// </summary>
            [EnumMember(Value = "views")]
            Views = 3,
            
            /// <summary>
            /// Enum Shares for value: shares
            /// </summary>
            [EnumMember(Value = "shares")]
            Shares = 4,
            
            /// <summary>
            /// Enum Downloads for value: downloads
            /// </summary>
            [EnumMember(Value = "downloads")]
            Downloads = 5,
            
            /// <summary>
            /// Enum Cites for value: cites
            /// </summary>
            [EnumMember(Value = "cites")]
            Cites = 6
        }

        /// <summary>
        /// The field by which to order. Default varies by endpoint/resource.
        /// </summary>
        /// <value>The field by which to order. Default varies by endpoint/resource.</value>
        [DataMember(Name="order", EmitDefaultValue=false)]
        public OrderEnum? Order { get; set; }
        /// <summary>
        /// Direction of ordering
        /// </summary>
        /// <value>Direction of ordering</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum OrderDirectionEnum
        {
            
            /// <summary>
            /// Enum Asc for value: asc
            /// </summary>
            [EnumMember(Value = "asc")]
            Asc = 1,
            
            /// <summary>
            /// Enum Desc for value: desc
            /// </summary>
            [EnumMember(Value = "desc")]
            Desc = 2
        }

        /// <summary>
        /// Direction of ordering
        /// </summary>
        /// <value>Direction of ordering</value>
        [DataMember(Name="order_direction", EmitDefaultValue=false)]
        public OrderDirectionEnum? OrderDirection { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="PrivateAuthorsSearch" /> class.
        /// </summary>
        /// <param name="searchFor">Search term.</param>
        /// <param name="page">Page number. Used for pagination with page_size.</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (default to 10).</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query.</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit.</param>
        /// <param name="order">The field by which to order. Default varies by endpoint/resource. (default to OrderEnum.Publisheddate).</param>
        /// <param name="orderDirection">Direction of ordering (default to OrderDirectionEnum.Desc).</param>
        /// <param name="institutionId">Return only authors associated to this institution.</param>
        /// <param name="orcid">Orcid of author.</param>
        /// <param name="groupId">Return only authors in this group or subgroups of the group.</param>
        /// <param name="isActive">Return only active authors if True.</param>
        /// <param name="isPublic">Return only authors that have published items if True.</param>
        public PrivateAuthorsSearch(string searchFor = default(string), long? page = default(long?), long? pageSize = 10, long? limit = default(long?), long? offset = default(long?), OrderEnum? order = OrderEnum.Publisheddate, OrderDirectionEnum? orderDirection = OrderDirectionEnum.Desc, long? institutionId = default(long?), string orcid = default(string), long? groupId = default(long?), bool? isActive = default(bool?), bool? isPublic = default(bool?))
        {
            this.SearchFor = searchFor;
            this.Page = page;
            // use default value if no "pageSize" provided
            if (pageSize == null)
            {
                this.PageSize = 10;
            }
            else
            {
                this.PageSize = pageSize;
            }
            this.Limit = limit;
            this.Offset = offset;
            // use default value if no "order" provided
            if (order == null)
            {
                this.Order = OrderEnum.Publisheddate;
            }
            else
            {
                this.Order = order;
            }
            // use default value if no "orderDirection" provided
            if (orderDirection == null)
            {
                this.OrderDirection = OrderDirectionEnum.Desc;
            }
            else
            {
                this.OrderDirection = orderDirection;
            }
            this.InstitutionId = institutionId;
            this.Orcid = orcid;
            this.GroupId = groupId;
            this.IsActive = isActive;
            this.IsPublic = isPublic;
        }
        
        /// <summary>
        /// Search term
        /// </summary>
        /// <value>Search term</value>
        [DataMember(Name="search_for", EmitDefaultValue=false)]
        public string SearchFor { get; set; }

        /// <summary>
        /// Page number. Used for pagination with page_size
        /// </summary>
        /// <value>Page number. Used for pagination with page_size</value>
        [DataMember(Name="page", EmitDefaultValue=false)]
        public long? Page { get; set; }

        /// <summary>
        /// The number of results included on a page. Used for pagination with page
        /// </summary>
        /// <value>The number of results included on a page. Used for pagination with page</value>
        [DataMember(Name="page_size", EmitDefaultValue=false)]
        public long? PageSize { get; set; }

        /// <summary>
        /// Number of results included on a page. Used for pagination with query
        /// </summary>
        /// <value>Number of results included on a page. Used for pagination with query</value>
        [DataMember(Name="limit", EmitDefaultValue=false)]
        public long? Limit { get; set; }

        /// <summary>
        /// Where to start the listing(the offset of the first result). Used for pagination with limit
        /// </summary>
        /// <value>Where to start the listing(the offset of the first result). Used for pagination with limit</value>
        [DataMember(Name="offset", EmitDefaultValue=false)]
        public long? Offset { get; set; }



        /// <summary>
        /// Return only authors associated to this institution
        /// </summary>
        /// <value>Return only authors associated to this institution</value>
        [DataMember(Name="institution_id", EmitDefaultValue=false)]
        public long? InstitutionId { get; set; }

        /// <summary>
        /// Orcid of author
        /// </summary>
        /// <value>Orcid of author</value>
        [DataMember(Name="orcid", EmitDefaultValue=false)]
        public string Orcid { get; set; }

        /// <summary>
        /// Return only authors in this group or subgroups of the group
        /// </summary>
        /// <value>Return only authors in this group or subgroups of the group</value>
        [DataMember(Name="group_id", EmitDefaultValue=false)]
        public long? GroupId { get; set; }

        /// <summary>
        /// Return only active authors if True
        /// </summary>
        /// <value>Return only active authors if True</value>
        [DataMember(Name="is_active", EmitDefaultValue=false)]
        public bool? IsActive { get; set; }

        /// <summary>
        /// Return only authors that have published items if True
        /// </summary>
        /// <value>Return only authors that have published items if True</value>
        [DataMember(Name="is_public", EmitDefaultValue=false)]
        public bool? IsPublic { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class PrivateAuthorsSearch {\n");
            sb.Append("  SearchFor: ").Append(SearchFor).Append("\n");
            sb.Append("  Page: ").Append(Page).Append("\n");
            sb.Append("  PageSize: ").Append(PageSize).Append("\n");
            sb.Append("  Limit: ").Append(Limit).Append("\n");
            sb.Append("  Offset: ").Append(Offset).Append("\n");
            sb.Append("  Order: ").Append(Order).Append("\n");
            sb.Append("  OrderDirection: ").Append(OrderDirection).Append("\n");
            sb.Append("  InstitutionId: ").Append(InstitutionId).Append("\n");
            sb.Append("  Orcid: ").Append(Orcid).Append("\n");
            sb.Append("  GroupId: ").Append(GroupId).Append("\n");
            sb.Append("  IsActive: ").Append(IsActive).Append("\n");
            sb.Append("  IsPublic: ").Append(IsPublic).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as PrivateAuthorsSearch);
        }

        /// <summary>
        /// Returns true if PrivateAuthorsSearch instances are equal
        /// </summary>
        /// <param name="input">Instance of PrivateAuthorsSearch to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(PrivateAuthorsSearch input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.SearchFor == input.SearchFor ||
                    (this.SearchFor != null &&
                    this.SearchFor.Equals(input.SearchFor))
                ) && 
                (
                    this.Page == input.Page ||
                    (this.Page != null &&
                    this.Page.Equals(input.Page))
                ) && 
                (
                    this.PageSize == input.PageSize ||
                    (this.PageSize != null &&
                    this.PageSize.Equals(input.PageSize))
                ) && 
                (
                    this.Limit == input.Limit ||
                    (this.Limit != null &&
                    this.Limit.Equals(input.Limit))
                ) && 
                (
                    this.Offset == input.Offset ||
                    (this.Offset != null &&
                    this.Offset.Equals(input.Offset))
                ) && 
                (
                    this.Order == input.Order ||
                    (this.Order != null &&
                    this.Order.Equals(input.Order))
                ) && 
                (
                    this.OrderDirection == input.OrderDirection ||
                    (this.OrderDirection != null &&
                    this.OrderDirection.Equals(input.OrderDirection))
                ) && 
                (
                    this.InstitutionId == input.InstitutionId ||
                    (this.InstitutionId != null &&
                    this.InstitutionId.Equals(input.InstitutionId))
                ) && 
                (
                    this.Orcid == input.Orcid ||
                    (this.Orcid != null &&
                    this.Orcid.Equals(input.Orcid))
                ) && 
                (
                    this.GroupId == input.GroupId ||
                    (this.GroupId != null &&
                    this.GroupId.Equals(input.GroupId))
                ) && 
                (
                    this.IsActive == input.IsActive ||
                    (this.IsActive != null &&
                    this.IsActive.Equals(input.IsActive))
                ) && 
                (
                    this.IsPublic == input.IsPublic ||
                    (this.IsPublic != null &&
                    this.IsPublic.Equals(input.IsPublic))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.SearchFor != null)
                    hashCode = hashCode * 59 + this.SearchFor.GetHashCode();
                if (this.Page != null)
                    hashCode = hashCode * 59 + this.Page.GetHashCode();
                if (this.PageSize != null)
                    hashCode = hashCode * 59 + this.PageSize.GetHashCode();
                if (this.Limit != null)
                    hashCode = hashCode * 59 + this.Limit.GetHashCode();
                if (this.Offset != null)
                    hashCode = hashCode * 59 + this.Offset.GetHashCode();
                if (this.Order != null)
                    hashCode = hashCode * 59 + this.Order.GetHashCode();
                if (this.OrderDirection != null)
                    hashCode = hashCode * 59 + this.OrderDirection.GetHashCode();
                if (this.InstitutionId != null)
                    hashCode = hashCode * 59 + this.InstitutionId.GetHashCode();
                if (this.Orcid != null)
                    hashCode = hashCode * 59 + this.Orcid.GetHashCode();
                if (this.GroupId != null)
                    hashCode = hashCode * 59 + this.GroupId.GetHashCode();
                if (this.IsActive != null)
                    hashCode = hashCode * 59 + this.IsActive.GetHashCode();
                if (this.IsPublic != null)
                    hashCode = hashCode * 59 + this.IsPublic.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Page (long?) maximum
            if(this.Page > (long?)5000)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Page, must be a value less than or equal to 5000.", new [] { "Page" });
            }

            // Page (long?) minimum
            if(this.Page < (long?)1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Page, must be a value greater than or equal to 1.", new [] { "Page" });
            }

            // PageSize (long?) maximum
            if(this.PageSize > (long?)1000)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for PageSize, must be a value less than or equal to 1000.", new [] { "PageSize" });
            }

            // PageSize (long?) minimum
            if(this.PageSize < (long?)1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for PageSize, must be a value greater than or equal to 1.", new [] { "PageSize" });
            }

            // Limit (long?) maximum
            if(this.Limit > (long?)1000)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Limit, must be a value less than or equal to 1000.", new [] { "Limit" });
            }

            // Limit (long?) minimum
            if(this.Limit < (long?)1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Limit, must be a value greater than or equal to 1.", new [] { "Limit" });
            }

            // Offset (long?) maximum
            if(this.Offset > (long?)5000)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Offset, must be a value less than or equal to 5000.", new [] { "Offset" });
            }

            // Offset (long?) minimum
            if(this.Offset < (long?)0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Offset, must be a value greater than or equal to 0.", new [] { "Offset" });
            }

            yield break;
        }
    }

}
