/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// PrivateLinkCreator
    /// </summary>
    [DataContract]
    public partial class PrivateLinkCreator :  IEquatable<PrivateLinkCreator>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="PrivateLinkCreator" /> class.
        /// </summary>
        /// <param name="expiresDate">Date when this private link should expire - optional. By default private links expire in 365 days..</param>
        /// <param name="readOnly">Optional, default true. Set to false to give private link users editing rights for this collection..</param>
        public PrivateLinkCreator(string expiresDate = default(string), bool? readOnly = default(bool?))
        {
            this.ExpiresDate = expiresDate;
            this.ReadOnly = readOnly;
        }
        
        /// <summary>
        /// Date when this private link should expire - optional. By default private links expire in 365 days.
        /// </summary>
        /// <value>Date when this private link should expire - optional. By default private links expire in 365 days.</value>
        [DataMember(Name="expires_date", EmitDefaultValue=false)]
        public string ExpiresDate { get; set; }

        /// <summary>
        /// Optional, default true. Set to false to give private link users editing rights for this collection.
        /// </summary>
        /// <value>Optional, default true. Set to false to give private link users editing rights for this collection.</value>
        [DataMember(Name="read_only", EmitDefaultValue=false)]
        public bool? ReadOnly { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class PrivateLinkCreator {\n");
            sb.Append("  ExpiresDate: ").Append(ExpiresDate).Append("\n");
            sb.Append("  ReadOnly: ").Append(ReadOnly).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as PrivateLinkCreator);
        }

        /// <summary>
        /// Returns true if PrivateLinkCreator instances are equal
        /// </summary>
        /// <param name="input">Instance of PrivateLinkCreator to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(PrivateLinkCreator input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ExpiresDate == input.ExpiresDate ||
                    (this.ExpiresDate != null &&
                    this.ExpiresDate.Equals(input.ExpiresDate))
                ) && 
                (
                    this.ReadOnly == input.ReadOnly ||
                    (this.ReadOnly != null &&
                    this.ReadOnly.Equals(input.ReadOnly))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ExpiresDate != null)
                    hashCode = hashCode * 59 + this.ExpiresDate.GetHashCode();
                if (this.ReadOnly != null)
                    hashCode = hashCode * 59 + this.ReadOnly.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
