/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ProjectCompletePrivate
    /// </summary>
    [DataContract]
    public partial class ProjectCompletePrivate : ProjectPrivate,  IEquatable<ProjectCompletePrivate>, IValidatableObject
    {
        /// <summary>
        /// Role inside this project
        /// </summary>
        /// <value>Role inside this project</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum RoleEnum
        {
            
            /// <summary>
            /// Enum Owner for value: Owner
            /// </summary>
            [EnumMember(Value = "Owner")]
            Owner = 1,
            
            /// <summary>
            /// Enum Collaborator for value: Collaborator
            /// </summary>
            [EnumMember(Value = "Collaborator")]
            Collaborator = 2,
            
            /// <summary>
            /// Enum Viewer for value: Viewer
            /// </summary>
            [EnumMember(Value = "Viewer")]
            Viewer = 3
        }

        /// <summary>
        /// Role inside this project
        /// </summary>
        /// <value>Role inside this project</value>
        [DataMember(Name="role", EmitDefaultValue=false)]
        public RoleEnum? Role { get; set; }
        /// <summary>
        /// Project storage type
        /// </summary>
        /// <value>Project storage type</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum StorageEnum
        {
            
            /// <summary>
            /// Enum Individual for value: individual
            /// </summary>
            [EnumMember(Value = "individual")]
            Individual = 1,
            
            /// <summary>
            /// Enum Group for value: group
            /// </summary>
            [EnumMember(Value = "group")]
            Group = 2
        }

        /// <summary>
        /// Project storage type
        /// </summary>
        /// <value>Project storage type</value>
        [DataMember(Name="storage", EmitDefaultValue=false)]
        public StorageEnum? Storage { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectCompletePrivate" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ProjectCompletePrivate() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectCompletePrivate" /> class.
        /// </summary>
        /// <param name="role">Role inside this project.</param>
        /// <param name="storage">Project storage type.</param>
        /// <param name="url">Api endpoint (required).</param>
        /// <param name="id">Project id (required).</param>
        /// <param name="title">Project title (required).</param>
        /// <param name="funding">Project funding (required).</param>
        /// <param name="fundingList">Full Project funding information (required).</param>
        /// <param name="description">Project description (required).</param>
        /// <param name="collaborators">List of project collaborators (required).</param>
        /// <param name="quota">Project quota (required).</param>
        /// <param name="usedQuota">Project used quota (required).</param>
        /// <param name="createdDate">Date when project was created (required).</param>
        /// <param name="modifiedDate">Date when project was last modified (required).</param>
        /// <param name="usedQuotaPrivate">Project private quota used (required).</param>
        /// <param name="usedQuotaPublic">Project public quota used (required).</param>
        /// <param name="groupId">Group of project if any (required).</param>
        /// <param name="accountId">ID of the account owning the project (required).</param>
        /// <param name="customFields">Collection custom fields (required).</param>
        public ProjectCompletePrivate(RoleEnum? role = default(RoleEnum?), StorageEnum? storage = default(StorageEnum?), string url = default(string), long? id = default(long?), string title = default(string), string funding = default(string), List<FundingInformation> fundingList = default(List<FundingInformation>), string description = default(string), List<Collaborator> collaborators = default(List<Collaborator>), long? quota = default(long?), long? usedQuota = default(long?), string createdDate = default(string), string modifiedDate = default(string), long? usedQuotaPrivate = default(long?), long? usedQuotaPublic = default(long?), long? groupId = default(long?), long? accountId = default(long?), List<CustomArticleField> customFields = default(List<CustomArticleField>)) : base()
        {
            // to ensure "url" is required (not null)
            if (url == null)
            {
                throw new InvalidDataException("url is a required property for ProjectCompletePrivate and cannot be null");
            }
            else
            {
                this.Url = url;
            }
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new InvalidDataException("id is a required property for ProjectCompletePrivate and cannot be null");
            }
            else
            {
                this.Id = id;
            }
            // to ensure "title" is required (not null)
            if (title == null)
            {
                throw new InvalidDataException("title is a required property for ProjectCompletePrivate and cannot be null");
            }
            else
            {
                this.Title = title;
            }
            // to ensure "funding" is required (not null)
            if (funding == null)
            {
                throw new InvalidDataException("funding is a required property for ProjectCompletePrivate and cannot be null");
            }
            else
            {
                this.Funding = funding;
            }
            // to ensure "fundingList" is required (not null)
            if (fundingList == null)
            {
                throw new InvalidDataException("fundingList is a required property for ProjectCompletePrivate and cannot be null");
            }
            else
            {
                this.FundingList = fundingList;
            }
            // to ensure "description" is required (not null)
            if (description == null)
            {
                throw new InvalidDataException("description is a required property for ProjectCompletePrivate and cannot be null");
            }
            else
            {
                this.Description = description;
            }
            // to ensure "collaborators" is required (not null)
            if (collaborators == null)
            {
                throw new InvalidDataException("collaborators is a required property for ProjectCompletePrivate and cannot be null");
            }
            else
            {
                this.Collaborators = collaborators;
            }
            // to ensure "quota" is required (not null)
            if (quota == null)
            {
                throw new InvalidDataException("quota is a required property for ProjectCompletePrivate and cannot be null");
            }
            else
            {
                this.Quota = quota;
            }
            // to ensure "usedQuota" is required (not null)
            if (usedQuota == null)
            {
                throw new InvalidDataException("usedQuota is a required property for ProjectCompletePrivate and cannot be null");
            }
            else
            {
                this.UsedQuota = usedQuota;
            }
            // to ensure "createdDate" is required (not null)
            if (createdDate == null)
            {
                throw new InvalidDataException("createdDate is a required property for ProjectCompletePrivate and cannot be null");
            }
            else
            {
                this.CreatedDate = createdDate;
            }
            // to ensure "modifiedDate" is required (not null)
            if (modifiedDate == null)
            {
                throw new InvalidDataException("modifiedDate is a required property for ProjectCompletePrivate and cannot be null");
            }
            else
            {
                this.ModifiedDate = modifiedDate;
            }
            // to ensure "usedQuotaPrivate" is required (not null)
            if (usedQuotaPrivate == null)
            {
                throw new InvalidDataException("usedQuotaPrivate is a required property for ProjectCompletePrivate and cannot be null");
            }
            else
            {
                this.UsedQuotaPrivate = usedQuotaPrivate;
            }
            // to ensure "usedQuotaPublic" is required (not null)
            if (usedQuotaPublic == null)
            {
                throw new InvalidDataException("usedQuotaPublic is a required property for ProjectCompletePrivate and cannot be null");
            }
            else
            {
                this.UsedQuotaPublic = usedQuotaPublic;
            }
            // to ensure "groupId" is required (not null)
            if (groupId == null)
            {
                throw new InvalidDataException("groupId is a required property for ProjectCompletePrivate and cannot be null");
            }
            else
            {
                this.GroupId = groupId;
            }
            // to ensure "accountId" is required (not null)
            if (accountId == null)
            {
                throw new InvalidDataException("accountId is a required property for ProjectCompletePrivate and cannot be null");
            }
            else
            {
                this.AccountId = accountId;
            }
            // to ensure "customFields" is required (not null)
            if (customFields == null)
            {
                throw new InvalidDataException("customFields is a required property for ProjectCompletePrivate and cannot be null");
            }
            else
            {
                this.CustomFields = customFields;
            }
            this.Role = role;
            this.Storage = storage;
        }
        


        /// <summary>
        /// Api endpoint
        /// </summary>
        /// <value>Api endpoint</value>
        [DataMember(Name="url", EmitDefaultValue=false)]
        public string Url { get; set; }

        /// <summary>
        /// Project id
        /// </summary>
        /// <value>Project id</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public long? Id { get; set; }

        /// <summary>
        /// Project title
        /// </summary>
        /// <value>Project title</value>
        [DataMember(Name="title", EmitDefaultValue=false)]
        public string Title { get; set; }

        /// <summary>
        /// Project funding
        /// </summary>
        /// <value>Project funding</value>
        [DataMember(Name="funding", EmitDefaultValue=false)]
        public string Funding { get; set; }

        /// <summary>
        /// Full Project funding information
        /// </summary>
        /// <value>Full Project funding information</value>
        [DataMember(Name="funding_list", EmitDefaultValue=false)]
        public List<FundingInformation> FundingList { get; set; }

        /// <summary>
        /// Project description
        /// </summary>
        /// <value>Project description</value>
        [DataMember(Name="description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// List of project collaborators
        /// </summary>
        /// <value>List of project collaborators</value>
        [DataMember(Name="collaborators", EmitDefaultValue=false)]
        public List<Collaborator> Collaborators { get; set; }

        /// <summary>
        /// Project quota
        /// </summary>
        /// <value>Project quota</value>
        [DataMember(Name="quota", EmitDefaultValue=false)]
        public long? Quota { get; set; }

        /// <summary>
        /// Project used quota
        /// </summary>
        /// <value>Project used quota</value>
        [DataMember(Name="used_quota", EmitDefaultValue=false)]
        public long? UsedQuota { get; set; }

        /// <summary>
        /// Date when project was created
        /// </summary>
        /// <value>Date when project was created</value>
        [DataMember(Name="created_date", EmitDefaultValue=false)]
        public string CreatedDate { get; set; }

        /// <summary>
        /// Date when project was last modified
        /// </summary>
        /// <value>Date when project was last modified</value>
        [DataMember(Name="modified_date", EmitDefaultValue=false)]
        public string ModifiedDate { get; set; }

        /// <summary>
        /// Project private quota used
        /// </summary>
        /// <value>Project private quota used</value>
        [DataMember(Name="used_quota_private", EmitDefaultValue=false)]
        public long? UsedQuotaPrivate { get; set; }

        /// <summary>
        /// Project public quota used
        /// </summary>
        /// <value>Project public quota used</value>
        [DataMember(Name="used_quota_public", EmitDefaultValue=false)]
        public long? UsedQuotaPublic { get; set; }

        /// <summary>
        /// Group of project if any
        /// </summary>
        /// <value>Group of project if any</value>
        [DataMember(Name="group_id", EmitDefaultValue=false)]
        public long? GroupId { get; set; }

        /// <summary>
        /// ID of the account owning the project
        /// </summary>
        /// <value>ID of the account owning the project</value>
        [DataMember(Name="account_id", EmitDefaultValue=false)]
        public long? AccountId { get; set; }

        /// <summary>
        /// Collection custom fields
        /// </summary>
        /// <value>Collection custom fields</value>
        [DataMember(Name="custom_fields", EmitDefaultValue=false)]
        public List<CustomArticleField> CustomFields { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ProjectCompletePrivate {\n");
            sb.Append("  ").Append(base.ToString().Replace("\n", "\n  ")).Append("\n");
            sb.Append("  Role: ").Append(Role).Append("\n");
            sb.Append("  Storage: ").Append(Storage).Append("\n");
            sb.Append("  Url: ").Append(Url).Append("\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Title: ").Append(Title).Append("\n");
            sb.Append("  Funding: ").Append(Funding).Append("\n");
            sb.Append("  FundingList: ").Append(FundingList).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  Collaborators: ").Append(Collaborators).Append("\n");
            sb.Append("  Quota: ").Append(Quota).Append("\n");
            sb.Append("  UsedQuota: ").Append(UsedQuota).Append("\n");
            sb.Append("  CreatedDate: ").Append(CreatedDate).Append("\n");
            sb.Append("  ModifiedDate: ").Append(ModifiedDate).Append("\n");
            sb.Append("  UsedQuotaPrivate: ").Append(UsedQuotaPrivate).Append("\n");
            sb.Append("  UsedQuotaPublic: ").Append(UsedQuotaPublic).Append("\n");
            sb.Append("  GroupId: ").Append(GroupId).Append("\n");
            sb.Append("  AccountId: ").Append(AccountId).Append("\n");
            sb.Append("  CustomFields: ").Append(CustomFields).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public override string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProjectCompletePrivate);
        }

        /// <summary>
        /// Returns true if ProjectCompletePrivate instances are equal
        /// </summary>
        /// <param name="input">Instance of ProjectCompletePrivate to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProjectCompletePrivate input)
        {
            if (input == null)
                return false;

            return base.Equals(input) && 
                (
                    this.Role == input.Role ||
                    (this.Role != null &&
                    this.Role.Equals(input.Role))
                ) && base.Equals(input) && 
                (
                    this.Storage == input.Storage ||
                    (this.Storage != null &&
                    this.Storage.Equals(input.Storage))
                ) && base.Equals(input) && 
                (
                    this.Url == input.Url ||
                    (this.Url != null &&
                    this.Url.Equals(input.Url))
                ) && base.Equals(input) && 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && base.Equals(input) && 
                (
                    this.Title == input.Title ||
                    (this.Title != null &&
                    this.Title.Equals(input.Title))
                ) && base.Equals(input) && 
                (
                    this.Funding == input.Funding ||
                    (this.Funding != null &&
                    this.Funding.Equals(input.Funding))
                ) && base.Equals(input) && 
                (
                    this.FundingList == input.FundingList ||
                    this.FundingList != null &&
                    this.FundingList.SequenceEqual(input.FundingList)
                ) && base.Equals(input) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && base.Equals(input) && 
                (
                    this.Collaborators == input.Collaborators ||
                    this.Collaborators != null &&
                    this.Collaborators.SequenceEqual(input.Collaborators)
                ) && base.Equals(input) && 
                (
                    this.Quota == input.Quota ||
                    (this.Quota != null &&
                    this.Quota.Equals(input.Quota))
                ) && base.Equals(input) && 
                (
                    this.UsedQuota == input.UsedQuota ||
                    (this.UsedQuota != null &&
                    this.UsedQuota.Equals(input.UsedQuota))
                ) && base.Equals(input) && 
                (
                    this.CreatedDate == input.CreatedDate ||
                    (this.CreatedDate != null &&
                    this.CreatedDate.Equals(input.CreatedDate))
                ) && base.Equals(input) && 
                (
                    this.ModifiedDate == input.ModifiedDate ||
                    (this.ModifiedDate != null &&
                    this.ModifiedDate.Equals(input.ModifiedDate))
                ) && base.Equals(input) && 
                (
                    this.UsedQuotaPrivate == input.UsedQuotaPrivate ||
                    (this.UsedQuotaPrivate != null &&
                    this.UsedQuotaPrivate.Equals(input.UsedQuotaPrivate))
                ) && base.Equals(input) && 
                (
                    this.UsedQuotaPublic == input.UsedQuotaPublic ||
                    (this.UsedQuotaPublic != null &&
                    this.UsedQuotaPublic.Equals(input.UsedQuotaPublic))
                ) && base.Equals(input) && 
                (
                    this.GroupId == input.GroupId ||
                    (this.GroupId != null &&
                    this.GroupId.Equals(input.GroupId))
                ) && base.Equals(input) && 
                (
                    this.AccountId == input.AccountId ||
                    (this.AccountId != null &&
                    this.AccountId.Equals(input.AccountId))
                ) && base.Equals(input) && 
                (
                    this.CustomFields == input.CustomFields ||
                    this.CustomFields != null &&
                    this.CustomFields.SequenceEqual(input.CustomFields)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = base.GetHashCode();
                if (this.Role != null)
                    hashCode = hashCode * 59 + this.Role.GetHashCode();
                if (this.Storage != null)
                    hashCode = hashCode * 59 + this.Storage.GetHashCode();
                if (this.Url != null)
                    hashCode = hashCode * 59 + this.Url.GetHashCode();
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.Title != null)
                    hashCode = hashCode * 59 + this.Title.GetHashCode();
                if (this.Funding != null)
                    hashCode = hashCode * 59 + this.Funding.GetHashCode();
                if (this.FundingList != null)
                    hashCode = hashCode * 59 + this.FundingList.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.Collaborators != null)
                    hashCode = hashCode * 59 + this.Collaborators.GetHashCode();
                if (this.Quota != null)
                    hashCode = hashCode * 59 + this.Quota.GetHashCode();
                if (this.UsedQuota != null)
                    hashCode = hashCode * 59 + this.UsedQuota.GetHashCode();
                if (this.CreatedDate != null)
                    hashCode = hashCode * 59 + this.CreatedDate.GetHashCode();
                if (this.ModifiedDate != null)
                    hashCode = hashCode * 59 + this.ModifiedDate.GetHashCode();
                if (this.UsedQuotaPrivate != null)
                    hashCode = hashCode * 59 + this.UsedQuotaPrivate.GetHashCode();
                if (this.UsedQuotaPublic != null)
                    hashCode = hashCode * 59 + this.UsedQuotaPublic.GetHashCode();
                if (this.GroupId != null)
                    hashCode = hashCode * 59 + this.GroupId.GetHashCode();
                if (this.AccountId != null)
                    hashCode = hashCode * 59 + this.AccountId.GetHashCode();
                if (this.CustomFields != null)
                    hashCode = hashCode * 59 + this.CustomFields.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            foreach(var x in BaseValidate(validationContext)) yield return x;
            yield break;
        }
    }

}
