/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// PublicFile
    /// </summary>
    [DataContract]
    public partial class PublicFile :  IEquatable<PublicFile>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="PublicFile" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected PublicFile() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="PublicFile" /> class.
        /// </summary>
        /// <param name="id">File id (required).</param>
        /// <param name="name">File name (required).</param>
        /// <param name="size">File size (required).</param>
        /// <param name="isLinkOnly">True if file is hosted somewhere else (required).</param>
        /// <param name="downloadUrl">Url for file download (required).</param>
        /// <param name="suppliedMd5">File supplied md5 (required).</param>
        /// <param name="computedMd5">File computed md5 (required).</param>
        /// <param name="mimetype">MIME Type of the file, it defaults to an empty string.</param>
        public PublicFile(long? id = default(long?), string name = default(string), long? size = default(long?), bool? isLinkOnly = default(bool?), string downloadUrl = default(string), string suppliedMd5 = default(string), string computedMd5 = default(string), string mimetype = default(string))
        {
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new InvalidDataException("id is a required property for PublicFile and cannot be null");
            }
            else
            {
                this.Id = id;
            }
            // to ensure "name" is required (not null)
            if (name == null)
            {
                throw new InvalidDataException("name is a required property for PublicFile and cannot be null");
            }
            else
            {
                this.Name = name;
            }
            // to ensure "size" is required (not null)
            if (size == null)
            {
                throw new InvalidDataException("size is a required property for PublicFile and cannot be null");
            }
            else
            {
                this.Size = size;
            }
            // to ensure "isLinkOnly" is required (not null)
            if (isLinkOnly == null)
            {
                throw new InvalidDataException("isLinkOnly is a required property for PublicFile and cannot be null");
            }
            else
            {
                this.IsLinkOnly = isLinkOnly;
            }
            // to ensure "downloadUrl" is required (not null)
            if (downloadUrl == null)
            {
                throw new InvalidDataException("downloadUrl is a required property for PublicFile and cannot be null");
            }
            else
            {
                this.DownloadUrl = downloadUrl;
            }
            // to ensure "suppliedMd5" is required (not null)
            if (suppliedMd5 == null)
            {
                throw new InvalidDataException("suppliedMd5 is a required property for PublicFile and cannot be null");
            }
            else
            {
                this.SuppliedMd5 = suppliedMd5;
            }
            // to ensure "computedMd5" is required (not null)
            if (computedMd5 == null)
            {
                throw new InvalidDataException("computedMd5 is a required property for PublicFile and cannot be null");
            }
            else
            {
                this.ComputedMd5 = computedMd5;
            }
            this.Mimetype = mimetype;
        }
        
        /// <summary>
        /// File id
        /// </summary>
        /// <value>File id</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public long? Id { get; set; }

        /// <summary>
        /// File name
        /// </summary>
        /// <value>File name</value>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// File size
        /// </summary>
        /// <value>File size</value>
        [DataMember(Name="size", EmitDefaultValue=false)]
        public long? Size { get; set; }

        /// <summary>
        /// True if file is hosted somewhere else
        /// </summary>
        /// <value>True if file is hosted somewhere else</value>
        [DataMember(Name="is_link_only", EmitDefaultValue=false)]
        public bool? IsLinkOnly { get; set; }

        /// <summary>
        /// Url for file download
        /// </summary>
        /// <value>Url for file download</value>
        [DataMember(Name="download_url", EmitDefaultValue=false)]
        public string DownloadUrl { get; set; }

        /// <summary>
        /// File supplied md5
        /// </summary>
        /// <value>File supplied md5</value>
        [DataMember(Name="supplied_md5", EmitDefaultValue=false)]
        public string SuppliedMd5 { get; set; }

        /// <summary>
        /// File computed md5
        /// </summary>
        /// <value>File computed md5</value>
        [DataMember(Name="computed_md5", EmitDefaultValue=false)]
        public string ComputedMd5 { get; set; }

        /// <summary>
        /// MIME Type of the file, it defaults to an empty string
        /// </summary>
        /// <value>MIME Type of the file, it defaults to an empty string</value>
        [DataMember(Name="mimetype", EmitDefaultValue=false)]
        public string Mimetype { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class PublicFile {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Size: ").Append(Size).Append("\n");
            sb.Append("  IsLinkOnly: ").Append(IsLinkOnly).Append("\n");
            sb.Append("  DownloadUrl: ").Append(DownloadUrl).Append("\n");
            sb.Append("  SuppliedMd5: ").Append(SuppliedMd5).Append("\n");
            sb.Append("  ComputedMd5: ").Append(ComputedMd5).Append("\n");
            sb.Append("  Mimetype: ").Append(Mimetype).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as PublicFile);
        }

        /// <summary>
        /// Returns true if PublicFile instances are equal
        /// </summary>
        /// <param name="input">Instance of PublicFile to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(PublicFile input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Size == input.Size ||
                    (this.Size != null &&
                    this.Size.Equals(input.Size))
                ) && 
                (
                    this.IsLinkOnly == input.IsLinkOnly ||
                    (this.IsLinkOnly != null &&
                    this.IsLinkOnly.Equals(input.IsLinkOnly))
                ) && 
                (
                    this.DownloadUrl == input.DownloadUrl ||
                    (this.DownloadUrl != null &&
                    this.DownloadUrl.Equals(input.DownloadUrl))
                ) && 
                (
                    this.SuppliedMd5 == input.SuppliedMd5 ||
                    (this.SuppliedMd5 != null &&
                    this.SuppliedMd5.Equals(input.SuppliedMd5))
                ) && 
                (
                    this.ComputedMd5 == input.ComputedMd5 ||
                    (this.ComputedMd5 != null &&
                    this.ComputedMd5.Equals(input.ComputedMd5))
                ) && 
                (
                    this.Mimetype == input.Mimetype ||
                    (this.Mimetype != null &&
                    this.Mimetype.Equals(input.Mimetype))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Size != null)
                    hashCode = hashCode * 59 + this.Size.GetHashCode();
                if (this.IsLinkOnly != null)
                    hashCode = hashCode * 59 + this.IsLinkOnly.GetHashCode();
                if (this.DownloadUrl != null)
                    hashCode = hashCode * 59 + this.DownloadUrl.GetHashCode();
                if (this.SuppliedMd5 != null)
                    hashCode = hashCode * 59 + this.SuppliedMd5.GetHashCode();
                if (this.ComputedMd5 != null)
                    hashCode = hashCode * 59 + this.ComputedMd5.GetHashCode();
                if (this.Mimetype != null)
                    hashCode = hashCode * 59 + this.Mimetype.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
