/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// RelatedMaterial
    /// </summary>
    [DataContract]
    public partial class RelatedMaterial :  IEquatable<RelatedMaterial>, IValidatableObject
    {
        /// <summary>
        /// The relation between the item and the related material; defaults to &#39;References&#39;. Mandatory if creating a new material.
        /// </summary>
        /// <value>The relation between the item and the related material; defaults to &#39;References&#39;. Mandatory if creating a new material.</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum RelationEnum
        {
            
            /// <summary>
            /// Enum IsCitedBy for value: IsCitedBy
            /// </summary>
            [EnumMember(Value = "IsCitedBy")]
            IsCitedBy = 1,
            
            /// <summary>
            /// Enum Cites for value: Cites
            /// </summary>
            [EnumMember(Value = "Cites")]
            Cites = 2,
            
            /// <summary>
            /// Enum IsSupplementTo for value: IsSupplementTo
            /// </summary>
            [EnumMember(Value = "IsSupplementTo")]
            IsSupplementTo = 3,
            
            /// <summary>
            /// Enum IsSupplementedBy for value: IsSupplementedBy
            /// </summary>
            [EnumMember(Value = "IsSupplementedBy")]
            IsSupplementedBy = 4,
            
            /// <summary>
            /// Enum IsContinuedBy for value: IsContinuedBy
            /// </summary>
            [EnumMember(Value = "IsContinuedBy")]
            IsContinuedBy = 5,
            
            /// <summary>
            /// Enum Continues for value: Continues
            /// </summary>
            [EnumMember(Value = "Continues")]
            Continues = 6,
            
            /// <summary>
            /// Enum Describes for value: Describes
            /// </summary>
            [EnumMember(Value = "Describes")]
            Describes = 7,
            
            /// <summary>
            /// Enum IsDescribedBy for value: IsDescribedBy
            /// </summary>
            [EnumMember(Value = "IsDescribedBy")]
            IsDescribedBy = 8,
            
            /// <summary>
            /// Enum HasMetadata for value: HasMetadata
            /// </summary>
            [EnumMember(Value = "HasMetadata")]
            HasMetadata = 9,
            
            /// <summary>
            /// Enum IsMetadataFor for value: IsMetadataFor
            /// </summary>
            [EnumMember(Value = "IsMetadataFor")]
            IsMetadataFor = 10,
            
            /// <summary>
            /// Enum HasVersion for value: HasVersion
            /// </summary>
            [EnumMember(Value = "HasVersion")]
            HasVersion = 11,
            
            /// <summary>
            /// Enum IsVersionOf for value: IsVersionOf
            /// </summary>
            [EnumMember(Value = "IsVersionOf")]
            IsVersionOf = 12,
            
            /// <summary>
            /// Enum IsNewVersionOf for value: IsNewVersionOf
            /// </summary>
            [EnumMember(Value = "IsNewVersionOf")]
            IsNewVersionOf = 13,
            
            /// <summary>
            /// Enum IsPreviousVersionOf for value: IsPreviousVersionOf
            /// </summary>
            [EnumMember(Value = "IsPreviousVersionOf")]
            IsPreviousVersionOf = 14,
            
            /// <summary>
            /// Enum IsPartOf for value: IsPartOf
            /// </summary>
            [EnumMember(Value = "IsPartOf")]
            IsPartOf = 15,
            
            /// <summary>
            /// Enum HasPart for value: HasPart
            /// </summary>
            [EnumMember(Value = "HasPart")]
            HasPart = 16,
            
            /// <summary>
            /// Enum IsPublishedIn for value: IsPublishedIn
            /// </summary>
            [EnumMember(Value = "IsPublishedIn")]
            IsPublishedIn = 17,
            
            /// <summary>
            /// Enum IsReferencedBy for value: IsReferencedBy
            /// </summary>
            [EnumMember(Value = "IsReferencedBy")]
            IsReferencedBy = 18,
            
            /// <summary>
            /// Enum References for value: References
            /// </summary>
            [EnumMember(Value = "References")]
            References = 19,
            
            /// <summary>
            /// Enum IsDocumentedBy for value: IsDocumentedBy
            /// </summary>
            [EnumMember(Value = "IsDocumentedBy")]
            IsDocumentedBy = 20,
            
            /// <summary>
            /// Enum Documents for value: Documents
            /// </summary>
            [EnumMember(Value = "Documents")]
            Documents = 21,
            
            /// <summary>
            /// Enum IsCompiledBy for value: IsCompiledBy
            /// </summary>
            [EnumMember(Value = "IsCompiledBy")]
            IsCompiledBy = 22,
            
            /// <summary>
            /// Enum Compiles for value: Compiles
            /// </summary>
            [EnumMember(Value = "Compiles")]
            Compiles = 23,
            
            /// <summary>
            /// Enum IsVariantFormOf for value: IsVariantFormOf
            /// </summary>
            [EnumMember(Value = "IsVariantFormOf")]
            IsVariantFormOf = 24,
            
            /// <summary>
            /// Enum IsOriginalFormOf for value: IsOriginalFormOf
            /// </summary>
            [EnumMember(Value = "IsOriginalFormOf")]
            IsOriginalFormOf = 25,
            
            /// <summary>
            /// Enum IsIdenticalTo for value: IsIdenticalTo
            /// </summary>
            [EnumMember(Value = "IsIdenticalTo")]
            IsIdenticalTo = 26,
            
            /// <summary>
            /// Enum IsReviewedBy for value: IsReviewedBy
            /// </summary>
            [EnumMember(Value = "IsReviewedBy")]
            IsReviewedBy = 27,
            
            /// <summary>
            /// Enum Reviews for value: Reviews
            /// </summary>
            [EnumMember(Value = "Reviews")]
            Reviews = 28,
            
            /// <summary>
            /// Enum IsDerivedFrom for value: IsDerivedFrom
            /// </summary>
            [EnumMember(Value = "IsDerivedFrom")]
            IsDerivedFrom = 29,
            
            /// <summary>
            /// Enum IsSourceOf for value: IsSourceOf
            /// </summary>
            [EnumMember(Value = "IsSourceOf")]
            IsSourceOf = 30,
            
            /// <summary>
            /// Enum IsRequiredBy for value: IsRequiredBy
            /// </summary>
            [EnumMember(Value = "IsRequiredBy")]
            IsRequiredBy = 31,
            
            /// <summary>
            /// Enum Requires for value: Requires
            /// </summary>
            [EnumMember(Value = "Requires")]
            Requires = 32,
            
            /// <summary>
            /// Enum IsObsoletedBy for value: IsObsoletedBy
            /// </summary>
            [EnumMember(Value = "IsObsoletedBy")]
            IsObsoletedBy = 33,
            
            /// <summary>
            /// Enum Obsoletes for value: Obsoletes
            /// </summary>
            [EnumMember(Value = "Obsoletes")]
            Obsoletes = 34
        }

        /// <summary>
        /// The relation between the item and the related material; defaults to &#39;References&#39;. Mandatory if creating a new material.
        /// </summary>
        /// <value>The relation between the item and the related material; defaults to &#39;References&#39;. Mandatory if creating a new material.</value>
        [DataMember(Name="relation", EmitDefaultValue=false)]
        public RelationEnum? Relation { get; set; }
        /// <summary>
        /// The type of the identifier of the related material; defaults to &#39;URL&#39;. Mandatory if creating a new material.
        /// </summary>
        /// <value>The type of the identifier of the related material; defaults to &#39;URL&#39;. Mandatory if creating a new material.</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum IdentifierTypeEnum
        {
            
            /// <summary>
            /// Enum ARK for value: ARK
            /// </summary>
            [EnumMember(Value = "ARK")]
            ARK = 1,
            
            /// <summary>
            /// Enum ArXiv for value: arXiv
            /// </summary>
            [EnumMember(Value = "arXiv")]
            ArXiv = 2,
            
            /// <summary>
            /// Enum Bibcode for value: bibcode
            /// </summary>
            [EnumMember(Value = "bibcode")]
            Bibcode = 3,
            
            /// <summary>
            /// Enum DOI for value: DOI
            /// </summary>
            [EnumMember(Value = "DOI")]
            DOI = 4,
            
            /// <summary>
            /// Enum EAN13 for value: EAN13
            /// </summary>
            [EnumMember(Value = "EAN13")]
            EAN13 = 5,
            
            /// <summary>
            /// Enum EISSN for value: EISSN
            /// </summary>
            [EnumMember(Value = "EISSN")]
            EISSN = 6,
            
            /// <summary>
            /// Enum Handle for value: Handle
            /// </summary>
            [EnumMember(Value = "Handle")]
            Handle = 7,
            
            /// <summary>
            /// Enum IGSN for value: IGSN
            /// </summary>
            [EnumMember(Value = "IGSN")]
            IGSN = 8,
            
            /// <summary>
            /// Enum ISBN for value: ISBN
            /// </summary>
            [EnumMember(Value = "ISBN")]
            ISBN = 9,
            
            /// <summary>
            /// Enum ISSN for value: ISSN
            /// </summary>
            [EnumMember(Value = "ISSN")]
            ISSN = 10,
            
            /// <summary>
            /// Enum ISTC for value: ISTC
            /// </summary>
            [EnumMember(Value = "ISTC")]
            ISTC = 11,
            
            /// <summary>
            /// Enum LISSN for value: LISSN
            /// </summary>
            [EnumMember(Value = "LISSN")]
            LISSN = 12,
            
            /// <summary>
            /// Enum LSID for value: LSID
            /// </summary>
            [EnumMember(Value = "LSID")]
            LSID = 13,
            
            /// <summary>
            /// Enum PMID for value: PMID
            /// </summary>
            [EnumMember(Value = "PMID")]
            PMID = 14,
            
            /// <summary>
            /// Enum PURL for value: PURL
            /// </summary>
            [EnumMember(Value = "PURL")]
            PURL = 15,
            
            /// <summary>
            /// Enum UPC for value: UPC
            /// </summary>
            [EnumMember(Value = "UPC")]
            UPC = 16,
            
            /// <summary>
            /// Enum URL for value: URL
            /// </summary>
            [EnumMember(Value = "URL")]
            URL = 17,
            
            /// <summary>
            /// Enum URN for value: URN
            /// </summary>
            [EnumMember(Value = "URN")]
            URN = 18,
            
            /// <summary>
            /// Enum W3id for value: w3id
            /// </summary>
            [EnumMember(Value = "w3id")]
            W3id = 19
        }

        /// <summary>
        /// The type of the identifier of the related material; defaults to &#39;URL&#39;. Mandatory if creating a new material.
        /// </summary>
        /// <value>The type of the identifier of the related material; defaults to &#39;URL&#39;. Mandatory if creating a new material.</value>
        [DataMember(Name="identifier_type", EmitDefaultValue=false)]
        public IdentifierTypeEnum? IdentifierType { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="RelatedMaterial" /> class.
        /// </summary>
        /// <param name="id">The ID of the related material; can be used to add existing materials of the same account to items..</param>
        /// <param name="identifier">The related material identifier (e.g., DOI, Handle, ISBN). Mandatory if creating a new material..</param>
        /// <param name="title">The related material title.</param>
        /// <param name="relation">The relation between the item and the related material; defaults to &#39;References&#39;. Mandatory if creating a new material. (default to RelationEnum.References).</param>
        /// <param name="identifierType">The type of the identifier of the related material; defaults to &#39;URL&#39;. Mandatory if creating a new material. (default to IdentifierTypeEnum.URL).</param>
        /// <param name="isLinkout">Flag for highlighting this related material in the call-out box.</param>
        public RelatedMaterial(long? id = default(long?), string identifier = default(string), string title = default(string), RelationEnum? relation = RelationEnum.References, IdentifierTypeEnum? identifierType = IdentifierTypeEnum.URL, bool? isLinkout = default(bool?))
        {
            this.Id = id;
            this.Identifier = identifier;
            this.Title = title;
            // use default value if no "relation" provided
            if (relation == null)
            {
                this.Relation = RelationEnum.References;
            }
            else
            {
                this.Relation = relation;
            }
            // use default value if no "identifierType" provided
            if (identifierType == null)
            {
                this.IdentifierType = IdentifierTypeEnum.URL;
            }
            else
            {
                this.IdentifierType = identifierType;
            }
            this.IsLinkout = isLinkout;
        }
        
        /// <summary>
        /// The ID of the related material; can be used to add existing materials of the same account to items.
        /// </summary>
        /// <value>The ID of the related material; can be used to add existing materials of the same account to items.</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public long? Id { get; set; }

        /// <summary>
        /// The related material identifier (e.g., DOI, Handle, ISBN). Mandatory if creating a new material.
        /// </summary>
        /// <value>The related material identifier (e.g., DOI, Handle, ISBN). Mandatory if creating a new material.</value>
        [DataMember(Name="identifier", EmitDefaultValue=false)]
        public string Identifier { get; set; }

        /// <summary>
        /// The related material title
        /// </summary>
        /// <value>The related material title</value>
        [DataMember(Name="title", EmitDefaultValue=false)]
        public string Title { get; set; }



        /// <summary>
        /// Flag for highlighting this related material in the call-out box
        /// </summary>
        /// <value>Flag for highlighting this related material in the call-out box</value>
        [DataMember(Name="is_linkout", EmitDefaultValue=false)]
        public bool? IsLinkout { get; set; }

        /// <summary>
        /// The full hyperlink for the identifier. Automatically generated by Figshare.
        /// </summary>
        /// <value>The full hyperlink for the identifier. Automatically generated by Figshare.</value>
        [DataMember(Name="link", EmitDefaultValue=false)]
        public string Link { get; private set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class RelatedMaterial {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Identifier: ").Append(Identifier).Append("\n");
            sb.Append("  Title: ").Append(Title).Append("\n");
            sb.Append("  Relation: ").Append(Relation).Append("\n");
            sb.Append("  IdentifierType: ").Append(IdentifierType).Append("\n");
            sb.Append("  IsLinkout: ").Append(IsLinkout).Append("\n");
            sb.Append("  Link: ").Append(Link).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as RelatedMaterial);
        }

        /// <summary>
        /// Returns true if RelatedMaterial instances are equal
        /// </summary>
        /// <param name="input">Instance of RelatedMaterial to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(RelatedMaterial input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.Identifier == input.Identifier ||
                    (this.Identifier != null &&
                    this.Identifier.Equals(input.Identifier))
                ) && 
                (
                    this.Title == input.Title ||
                    (this.Title != null &&
                    this.Title.Equals(input.Title))
                ) && 
                (
                    this.Relation == input.Relation ||
                    (this.Relation != null &&
                    this.Relation.Equals(input.Relation))
                ) && 
                (
                    this.IdentifierType == input.IdentifierType ||
                    (this.IdentifierType != null &&
                    this.IdentifierType.Equals(input.IdentifierType))
                ) && 
                (
                    this.IsLinkout == input.IsLinkout ||
                    (this.IsLinkout != null &&
                    this.IsLinkout.Equals(input.IsLinkout))
                ) && 
                (
                    this.Link == input.Link ||
                    (this.Link != null &&
                    this.Link.Equals(input.Link))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.Identifier != null)
                    hashCode = hashCode * 59 + this.Identifier.GetHashCode();
                if (this.Title != null)
                    hashCode = hashCode * 59 + this.Title.GetHashCode();
                if (this.Relation != null)
                    hashCode = hashCode * 59 + this.Relation.GetHashCode();
                if (this.IdentifierType != null)
                    hashCode = hashCode * 59 + this.IdentifierType.GetHashCode();
                if (this.IsLinkout != null)
                    hashCode = hashCode * 59 + this.IsLinkout.GetHashCode();
                if (this.Link != null)
                    hashCode = hashCode * 59 + this.Link.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
